'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var ninepatchCore = require('ninepatch-core');

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var index = (function (props) {
  var src = props.src,
      customOptions = props.customOptions;

  var _useState = React.useState({}),
      _useState2 = _slicedToArray(_useState, 2),
      padding = _useState2[0],
      setPadding = _useState2[1];

  var _useState3 = React.useState({}),
      _useState4 = _slicedToArray(_useState3, 2),
      borderImageSlice = _useState4[0],
      setBorderImageSlice = _useState4[1];

  var _useState5 = React.useState(0),
      _useState6 = _slicedToArray(_useState5, 2),
      clipPath = _useState6[0],
      setClipPath = _useState6[1];

  var getNinePatchData =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var np, chunk;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(src === '' || src === undefined)) {
                _context.next = 2;
                break;
              }

              return _context.abrupt("return", false);

            case 2:
              if (!customOptions) {
                _context.next = 8;
                break;
              }

              setPadding(customOptions.padding || {});
              setBorderImageSlice(customOptions.borderImageSlice || {});
              setClipPath(customOptions.clipPath || 0);
              _context.next = 16;
              break;

            case 8:
              np = new ninepatchCore.NinePatchCore(src);
              _context.next = 11;
              return np.getChunkData();

            case 11:
              chunk = _context.sent;
              console.log(chunk);
              setPadding(chunk.padding || {});
              setBorderImageSlice({
                top: chunk.yDivs.start,
                right: chunk.width - chunk.xDivs.stop,
                bottom: chunk.height - chunk.yDivs.stop,
                left: chunk.xDivs.start
              });
              setClipPath(chunk.clipPath || 0);

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function getNinePatchData() {
      return _ref.apply(this, arguments);
    };
  }();

  React.useEffect(function () {
    getNinePatchData();
  }, [src, customOptions]);
  var style = {
    height: '100%',
    borderImageSource: "url(".concat(src, ")"),
    padding: "".concat(padding.top, "px ").concat(padding.right, "px ").concat(padding.bottom, "px ").concat(padding.left, "px"),
    borderImageSlice: "".concat(borderImageSlice.top, " ").concat(borderImageSlice.right, " ").concat(borderImageSlice.bottom, " ").concat(borderImageSlice.left, " fill"),
    borderImageWidth: "".concat(borderImageSlice.top, "px ").concat(borderImageSlice.right, "px ").concat(borderImageSlice.bottom, "px ").concat(borderImageSlice.left, "px"),
    clipPath: "inset(".concat(clipPath, "px)")
  };
  return (
    /*#__PURE__*/
    React__default.createElement("div", {
      style: style
    }, props.children)
  );
});

module.exports = index;
//# sourceMappingURL=index.js.map
